var scriptletGlobals = new Map();

{
  const config = {
    "load": function () {
      const scriptlets = document.documentElement.getAttribute("scriptlets");
      //
      if (scriptlets) {
        config.action(scriptlets);
        document.documentElement.removeAttribute("scriptlets");
      } else {
        config.observer = new MutationObserver(config.listener);
        config.observer.observe(document.documentElement, {"attributes": true});
      }
    },
    "listener": function (mutations) {
      mutations.forEach(function (mutation) {
        if (mutation.type === "attributes") {
          const scriptlets = mutation.target.getAttribute("scriptlets");
          //
          if (scriptlets) {
            config.action(scriptlets);
            config.observer.disconnect();
            mutation.target.removeAttribute("scriptlets");
          }
        }
      });
    },
    "action": function (scriptlets) {
      if (scriptlets) {
        import(scriptlets).then(module => {
          for (const scriptlet of module.builtinScriptlets) {
            //
            if (scriptlet.name === "trusted-prevent-dom-bypass.js") {
              scriptlet.fn('Node.prototype.appendChild', 'fetch');
              scriptlet.fn('Node.prototype.appendChild', 'Request');
            }
            //
            if (scriptlet.name === "json-prune-xhr-response.js") {
              scriptlet.fn('playerAds adPlacements adSlots no_ads playerResponse.playerAds playerResponse.adPlacements playerResponse.adSlots playerResponse.no_ads [].playerResponse.adPlacements [].playerResponse.playerAds [].playerResponse.adSlots [].playerResponse.no_ads', '', 'propsToMatch', String.raw`/\/player(?:\?.+)?$/`);
            }
            //
            if (scriptlet.name === "json-prune-fetch-response.js") {
              scriptlet.fn('playerAds adPlacements adSlots no_ads playerResponse.playerAds playerResponse.adPlacements playerResponse.adSlots playerResponse.no_ads', '', 'propsToMatch', String.raw`/player?`);
              scriptlet.fn('playerAds adPlacements adSlots no_ads playerResponse.playerAds playerResponse.adPlacements playerResponse.adSlots playerResponse.no_ads', '', 'propsToMatch', String.raw`/playlist`);
              scriptlet.fn('reelWatchSequenceResponse.entries.[-].command.reelWatchEndpoint.adClientParams.isAd entries.[-].command.reelWatchEndpoint.adClientParams.isAd', '', 'propsToMatch', String.raw`url:/reel_watch_sequence?`);
              scriptlet.fn('playerAds adPlacements adSlots no_ads playerResponse.playerAds playerResponse.adPlacements playerResponse.adSlots playerResponse.no_ads [].playerResponse.adPlacements [].playerResponse.playerAds [].playerResponse.adSlots [].playerResponse.no_ads', '', 'propsToMatch', String.raw`/player\?|get_watch|^\W+$/`);
            }
            //
            if (scriptlet.name === "adjust-setTimeout.js") {
              scriptlet.fn('[native code]', '17000', '0.001');
            }
            //
            if (scriptlet.name === "trusted-replace-node-text.js") {
              scriptlet.fn('script', '(function serverContract()', String.raw`/*START*/"YOUTUBE_PREMIUM_LOGO"!==ytInitialData?.topbar?.desktopTopbarRenderer?.logo?.topbarLogoRenderer?.iconImage?.iconType&&(location.href.startsWith("https://www.youtube.com/tv#/")||location.href.startsWith("https://www.youtube.com/embed/")||document.addEventListener("DOMContentLoaded",(function(){const t=()=>{const t=document.getElementById("movie_player");if(!t)return;if(!t.getStatsForNerds?.()?.debug_info?.startsWith?.("SSAP, AD"))return;const e=t.getProgressState?.();e&&e.duration>0&&(e.loaded<e.duration||e.duration-e.current>1)&&t.seekTo?.(e.duration)};t(),new MutationObserver((()=>{t()})).observe(document,{childList:!0,subtree:!0})})));(function serverContract()`, 'sedCount', '1');
            }
            //
            if (scriptlet.name === "set-constant.js") {
              scriptlet.fn('playerResponse.adPlacements', 'undefined');
              scriptlet.fn('ytInitialPlayerResponse.adSlots', 'undefined');
              scriptlet.fn('ytInitialPlayerResponse.playerAds', 'undefined');
              scriptlet.fn('ytInitialPlayerResponse.adPlacements', 'undefined');
            }
            //
            if (scriptlet.name === "trusted-replace-fetch-response.js") {
              scriptlet.fn(String.raw`"adSlots"`, String.raw`"no_ads"`, String.raw`/^\W+$/`);
              scriptlet.fn(String.raw`"adSlots"`, String.raw`"no_ads"`, String.raw`player?`);
              scriptlet.fn(String.raw`"adPlacements"`, String.raw`"no_ads"`, String.raw`player?`);
            }
            //
            if (scriptlet.name === "trusted-replace-xhr-response.js") {
              scriptlet.fn(String.raw`/"adPlacements.*?("adSlots"|"adBreakHeartbeatParams")/gms`, '$1', String.raw`/\/player(?:\?.+)?$/`);
              scriptlet.fn(String.raw`/"adPlacements.*?([A-Z]"\}|"\}{2,4})\}\],/`, '', String.raw`/playlist\?list=|\/player(?:\?.+)?$|watch\?[tv]=/`);
            }
          }
        });
      }
    }
  };
  //
  config.load();
}
